CON

  _clkmode = xtal2 + pll16x          ' enable external clock and pll times 8
  _xinfreq = 6_000_000


OBJ

  text : "tv_text"
  hss  : "yma_hss_v1.2_hydra"
  key  : "keyboard"

VAR

  BYTE  Synth[12]
  
PUB start | x

''Start terminal screen
  text.start(24)
  
''Start Hybrid Keyboard
  key.start(12,13)
  
''Start HSS Sound Engine
  hss.start 'Start HSS Engine

'' Load in some default data  into sound envelope
  repeat x from 0 to 11
    Synth[x] := SoundFX[x]
    
  SetupScreen         ' Setup main screen display
  UpdateText          ' Show Synth envelope values
  key.clearkeys       ' Clear keyboard buffer
  
  repeat
    
    case key.getkey                         ' Wait for keypress
        $31: Synth[0] := Synth[0] +1 <# $06 ' Key 1
        $71: Synth[0] := Synth[0] -1 #> $00 ' Key Q
        
        $32: Synth[1] := Synth[1] +1 <# $FF ' Key 2
        $77: Synth[1] := Synth[1] -1 #> $00 ' Key W
        
        $33: Synth[2] := Synth[2] +1 <# $FF ' Key 3
        $65: Synth[2] := Synth[2] -1 #> $00 ' Key E
        
        $34: Synth[3] := Synth[3] +1 <# $0F ' Key 4
        $72: Synth[3] := Synth[3] -1 #> $00 ' Key R
        
        $35: Synth[4] := Synth[4] +1 <# $FF ' Key 5
        $74: Synth[4] := Synth[4] -1 #> $00 ' Key T
          
        $36: Synth[5] := Synth[5] +1 <# $05 ' Key 6
        $79: Synth[5] := Synth[5] -1 #> $00 ' Key Y
          
        $37: Synth[6] := Synth[6] +1 <# $FF ' Key 7
        $75: Synth[6] := Synth[6] -1 #> $00 ' Key U
          
        $38: Synth[7] := Synth[7] +1 <# $FF ' Key 8
        $69: Synth[7] := Synth[7] -1 #> $00 ' Key I
          
        $61: Synth[8] := Synth[8] +1 <# $FF ' Key A
        $7A: Synth[8] := Synth[8] -1 #> $00 ' Key Z
          
        $73: Synth[9] := Synth[9] +1 <# $FF ' Key S
        $78: Synth[9] := Synth[9] -1 #> $00 ' Key X
         
        $64: Synth[10] := Synth[10] +1 <# $FF ' Key D
        $63: Synth[10] := Synth[10] -1 #> $00 ' Key C
         
        $66: Synth[11] := Synth[11] +1 <# $FF ' Key F
        $76: Synth[11] := Synth[11] -1 #> $00 ' Key V
        " ": hss.sfx_play(1, @Synth)          ' Play Synth Envelope
    updatetext
  
pub colour(c)
    text.out(12)
    text.out(c)

pub cls
    text.out(0)

pub cursor(xpos,ypos)
    text.out($0A)
    text.out(xpos)
    text.out($0B)
    text.out(ypos)

pub SetupScreen

    cls
    colour(1)
    cursor(0,0)
    text.str(string("      HSS FM Synth Waveform Editor      "))
    colour(0)
    text.str(string("  1    2    3    4    5    6    7    8",13))
    colour(4)
    text.str(string(" Wav  Len  Fre  Vol  LFO  LFW  FMa  AMa "))
    text.str(string(" $    $    $    $    $    $    $    $   "))
    colour(0)
    text.str(string("  Q    W    E    R    T    Y    U    I",13,13))
    cursor(12,6)
    text.str(string("A    S    D    F"))
    colour(4)
    cursor(11,7)
    text.str(string("Att  Dec  Sus  Rel"))
    cursor(11,8)
    text.str(string("$    $    $    $  "))
    colour(0)
    cursor(12,9)
    text.str(string("Z    X    C    V"))
    colour(3)
    cursor(0,10)
    text.str(string("  Use keyboard to increase & decrease   "))
    cursor(0,11)
    text.str(string("  envelope values, Press Space to test  "))
    
pub UpdateText | x,y

    colour(4)
    y:=3
    Repeat x from 0 to 7
      cursor((x*5)+2,y)
      text.hex(Synth[x],2)
    y:=8
    Repeat x from 8 to 11
      cursor((x*5)-28,y)
      text.hex(Synth[x],2)
      
DAT

                                'Wav 'Len 'Fre 'Vol 'LFO 'LFW 'FMa 'AMa
SoundFX                 byte    $03, $20, $00, $0F, $01, $03, $01, $00    
                                'Att 'Dec 'Sus 'Rel
                        byte    $FF, $06, $00, $FF
                                                                           